;Colour bars program
;-------------------
;Binary created using DAsm 2.12 running on an Amiga.

   PROCESSOR   6502

DELAY EQU #$80

   ORG   $C000    ;16Kb PRG-ROM, 8Kb CHR-ROM

Reset_Routine  SUBROUTINE
   cld         ;Clear decimal flag
   sei         ;Disable interrupts
.WaitV   lda $2002
   bpl .WaitV     ;Wait for vertical blanking interval
   ldx #$00
   stx $2000
   stx $2001      ;Screen display off, amongst other things
   dex
   txs         ;Top of stack at $1FF

;Clear (most of) the NES' WRAM. This routine is ripped from "Duck Hunt" - I should probably clear all
;$800 bytes.
   ldy #$06    ;To clear 7 x $100 bytes, from $000 to $6FF?
   sty $01        ;Store count value in $01
   ldy #$00
   sty $00
   lda #$00

.Clear   sta ($00),y    ;Clear $100 bytes
   dey
   bne .Clear

   dec $01        ;Decrement "banks" left counter
   bpl .Clear     ;Do next if >= 0

   lda   #DELAY
   sta   $21      ;$21 holds frame delay
   sta   $22      ;$22 holds starting frame delay.


;********* Initialize Palette to specified colour ********

   ldy   #$00
   ldx   #$00
   stx   $20         ;Save starting index
   jsr   InitPal
   ldy   #$10
   ldx   #$00
   jsr   InitPal

;*********************************************************
;Draw Name Table

   lda   #$21
   sta   $2006
   lda   #$00
   sta   $2006       ;Point 8 rows down in Name Table.

   lda   #$0D        ;Draw 13 rows
   sta   $10
   lda   #$00
   tax
.DefMap0 ldy #$13    ;Save 19 characters per line
.DefMap1 stx $2007
   inx
   dey
   bne   .DefMap1

   ldy   #$0D        ;Draw 13 blank characters
.DefMap2 sta $2007
   dey
   bne   .DefMap2
   dec   $10
   bne   .DefMap0

;------------------------------
;Set up Attribute Table
   lda   #$23
   sta   $2006
   lda   #$D0
   sta   $2006       ;Point to right spot in Attr. Map

   ldx   #$00
   ldy   #$20
.DrawAtt lda .Attribute,X
   sta   $2007
   inx
   dey
   bne   .DrawAtt
;------------------------------
;Set up Sprites

   lda   #$00        ;Starting Sprite
   sta   $2003
   tax
   ldy   #64        ;Total Sprites to set up
.PutSpr lda .SpriteY,X
   sta   $2004
   stx   $2004
   lda   .SpriteAtt,X
   sta   $2004
   lda   .SpriteX,X
   sta   $2004
   inx
   dey
   bne   .PutSpr
;-------------------------------
   lda   #$00
   sta   $2006
   sta   $2006       ;Reset PPU
   sta   $2005
   sta   $2005       ;Reset Scroll

;Enable vblank interrupts, etc.
   lda   #%10001000
   sta   $2000
   lda   #%00011110   ;Screen on, sprites on, show leftmost 8 pixels, colour
   sta   $2001
;  cli            ;Enable interrupts(?)

;Now just loop forever?
.Loop jmp   .Loop

.Attribute  dc.b #$40,#$55,#$01,#$01,#$00,#$00,#$00,#$00
            dc.b #$04,#$05,#$51,#$00,#$00,#$00,#$00,#$00
            dc.b #$04,#$11,#$44,#$00,#$00,#$00,#$00,#$00
            dc.b #$04,#$01,#$00,#$00,#$01,#$00,#$00,#$00

.SpriteY    dc.b #$78,#$3F,#$47,#$3F,#$3F,#$47,#$47,#$3F
            dc.b #$47,#$47,#$4F,#$4F,#$57,#$57,#$47,#$8A
            dc.b #$6F,#$6F,#$77,#$77,#$8F,#$8D,#$97,#$7F
            dc.b #$6F,#$6F,#$77,#$77,#$6F,#$6F,#$77,#$77
            dc.b #$7F,#$87,#$8F,#$8F,#$97,#$67,#$67,#$5F
            dc.b #$5F,#$67,#$6F,#$7F,#$6B,#$6B,#$73,#$86
            dc.b #$7F,#$4F,#$57,#$5F,#$7F,#$5F,#$5A,#$5A
            dc.b #$68,#$6F,#$4C,#$8F,#$97,#$87,#$80,#$4E

.SpriteAtt  dc.b #$00,#$01,#$01,#$01,#$01,#$01,#$01,#$01
            dc.b #$01,#$01,#$01,#$01,#$01,#$01,#$00,#$01
            dc.b #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00
            dc.b #$01,#$01,#$01,#$01,#$01,#$01,#$01,#$01
            dc.b #$01,#$01,#$01,#$01,#$01,#$00,#$00,#$00
            dc.b #$00,#$00,#$00,#$01,#$01,#$01,#$01,#$01
            dc.b #$01,#$00,#$00,#$00,#$00,#$00,#$00,#$00
            dc.b #$01,#$01,#$00,#$01,#$01,#$00,#$01,#$00

.SpriteX    dc.b #$40,#$18,#$18,#$50,#$58,#$50,#$58,#$70
            dc.b #$70,#$78,#$40,#$48,#$40,#$48,#$48,#$30
            dc.b #$50,#$58,#$50,#$58,#$50,#$57,#$50,#$50
            dc.b #$19,#$21,#$19,#$21,#$0A,#$12,#$0A,#$12
            dc.b #$09,#$09,#$10,#$18,#$18,#$28,#$28,#$40
            dc.b #$48,#$48,#$48,#$46,#$74,#$7C,#$77,#$7D
            dc.b #$82,#$10,#$10,#$10,#$28,#$2B,#$32,#$3A
            dc.b #$0E,#$38,#$60,#$60,#$60,#$2D,#$60,#$68

InitPal SUBROUTINE
;----------------------------------------
; INPUTS: Y: PPU Palette Location
;         X: Index into Palette
;----------------------------------------
   pha
   txa
   pha
   tya
   pha

   lda   #$3F
   sta   $2006
   sty   $2006

   ldy   #$08     ;Set up 8 colours.
.InitPal1 lda .Palette,X
   sta $2007
   inx
   dey
   bne   .InitPal1

   pla
   tay
   pla
   tax
   pla
   rts

.Palette dc.b #$0D,#$1D,#$2D,#$00,#$0D,#$10,#$3D,#$30    ;Greys
         dc.b #$0D,#$07,#$16,#$27,#$0D,#$37,#$38,#$30    ;Red-Yellow
         dc.b #$0D,#$01,#$11,#$1C,#$0D,#$2C,#$3C,#$30    ;Blue-Cyan
         dc.b #$0D,#$03,#$14,#$25,#$0D,#$36,#$37,#$30    ;Magenta-Yellow
         dc.b #$0D,#$05,#$06,#$07,#$0D,#$17,#$18,#$28    ;Rusty
         dc.b #$0D,#$11,#$2C,#$2B,#$0D,#$2A,#$38,#$26    ;Spectrum1
         dc.b #$0D,#$16,#$39,#$2A,#$0D,#$2C,#$11,#$13

NMI_Routine SUBROUTINE
   pha
   txa
   pha
   tya
   pha

   dec   $21
   bne   .NoClear

   ldy   #$00
   ldx   $20         ;$20 holds palette index.
   jsr   InitPal
   ldy   #$10
   ldx   $20
   jsr   InitPal

   clc
   lda   #$08
   adc   $20         ;Add 8 to $20
   sta   $20

   dec   $22
   bne   .NoDelay
   lda   #DELAY
   sta   $22
.NoDelay lda   $22
   sta   $21

   lda   #$38
   cmp   $20
   bne   .NoClear
   lda   #$00
   sta   $20

.NoClear
   lda   #$00        ;Reset PPU.
   sta   $2006
   sta   $2006
   sta   $2005
   sta   $2005

   pla
   tay
   pla
   tax
   pla
   rti

IRQ_Routine       ;Dummy label
   rti


;That's all the code. Now we just need to set the vector table approriately.

   ORG   $FFFA,0
   dc.w  NMI_Routine
   dc.w  Reset_Routine
   dc.w  IRQ_Routine    ;Not used, just points to RTI


;The end.
